unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  damy:array[1..8] of integer;
  i,pd,r,s:integer;
  ok:boolean;
implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
  begin
    for i:=1 to 8 do damy[i]:=0;
    damy[1]:=1;
  end;

procedure TForm1.Button1Click(Sender: TObject);

  procedure skontroluj;
    begin
      ok:=true;{predpokladame, ze dama sa nekryje s inou damou}
      for r:=1 to pd-1 do {cyklus cez vsetky damy}
        begin
          if damy[r]=damy[pd] then ok:=false; {kontrola stlpca}
          if r+damy[r]=pd+damy[pd] then ok:=false; {kontrola diagonaly}
          if r-damy[r]=pd-damy[pd] then ok:=false; {kontrola diagonaly}
        end;
      if (not ok) and (damy[pd]<8)then
        begin
          inc(damy[pd]); {posun poslednej damy o 1 vpravo}
          skontroluj
        end
      else if(not ok)and(damy[pd]=8)then
        begin
          damy[pd]:=0; {poslednu damu presunieme opat na zaciatok}
          dec(pd); {znizime pocet umiestnenych dam}
          if damy[pd]<8 then inc(damy[pd]) {ak mozeme poslednu damu posunut
                                            vpravo, posunieme ju}
                        else begin         {ak nemozeme, znova}
                               damy[pd]:=0;{poslednu damu presunieme opat na zaciatok}
                               dec(pd);    {znizime pocet umiestnenych dam}
                               inc(damy[pd]);{posunieme poslednu damu vpravo}
                             end;
          skontroluj;
        end;
    end;

  procedure umiestnidamu;
    begin
      pd:=pd+1;{pocet dam}
      damy[pd]:=1;{dama sa polozi do 1. stlpca}
      skontroluj;{skontroluje, ci sa dama nekryje s inou uz polozenou damou}
    end;

  procedure vykresli;
    begin
      {vykreslenie sachovnice}
      Image1.Canvas.Pen.Color:=ClBlack;
      Image1.Canvas.Brush.Color:=ClBlack;
      Image1.Canvas.Rectangle(1,1,240,240);
      Image1.Canvas.Brush.Color:=ClWhite;
      for r:=1 to 8 do
        for s:=1 to 8 do
          if ((r+s) mod 2=0)then
            Image1.Canvas.Rectangle(30*s-29,30*r-29,30*s,30*r);
      {vykreslenie dam}
      Image1.Canvas.Brush.Color:=ClRed;
      for r:=1 to 8 do
        Image1.Canvas.Ellipse(30*damy[r]-25,30*r-25,30*damy[r]-5,30*r-5);
    end;

begin
  umiestnidamu;
  vykresli;
end;

end.
